export declare class Query<T> {
    data: T[];
    constructor(data: T[]);
    orderBy(condition: Array<string | string[]> | ((a: T, b: T) => number)): Query<T>;
    groupBy(condition: string[] | ((a: T, b: T, index: number, array: T[]) => boolean)): Query<T[]>;
    groupEvery(n: number | {
        single: number;
        first?: number;
        intermediate: number;
        last?: number;
    }): Query<T[]>;
    where(fn: (value: T, index: number, array: T[]) => boolean): Query<T>;
    select(): T[];
    select<R>(fn: (value: T, index: number, array: T[]) => R): R[];
}
export declare function query<T>(data: T[]): Query<T>;
