"use strict";
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
Object.defineProperty(exports, "__esModule", { value: true });
function quote(state, x) {
    return [{ symbol: state.config.reservedNames.quote }, x];
}
exports.quote = quote;
function isQuoted(state, x) {
    if (Array.isArray(x) && 0 < x.length) {
        const q = isSymbol(x);
        if (q && q.symbol === state.config.reservedNames.quote) {
            return true;
        }
    }
    return false;
}
exports.isQuoted = isQuoted;
function backquote(state, x) {
    return [{ symbol: state.config.reservedNames.backquote }, x];
}
exports.backquote = backquote;
function isBackquoted(state, x) {
    if (Array.isArray(x) && 0 < x.length) {
        const q = isSymbol(x);
        if (q && q.symbol === state.config.reservedNames.backquote) {
            return true;
        }
    }
    return false;
}
exports.isBackquoted = isBackquoted;
function wrapByUnquote(state, x) {
    return [{ symbol: state.config.reservedNames.unquote }, x];
}
exports.wrapByUnquote = wrapByUnquote;
function isUnquoted(state, x) {
    if (Array.isArray(x) && 0 < x.length) {
        const q = isSymbol(x);
        if (q && q.symbol === state.config.reservedNames.unquote) {
            return true;
        }
    }
    return false;
}
exports.isUnquoted = isUnquoted;
function spread(state, x) {
    return [{ symbol: state.config.reservedNames.spread }, x];
}
exports.spread = spread;
function splice(state, x) {
    return [{ symbol: state.config.reservedNames.splice }, x];
}
exports.splice = splice;
function isSymbol(x, name) {
    if (x && typeof x === 'object' && Object.prototype.hasOwnProperty.call(x, 'symbol')) {
        if (name !== void 0) {
            return x.symbol === name ? x : null;
        }
        else {
            return x;
        }
    }
    return null;
}
exports.isSymbol = isSymbol;
//# sourceMappingURL=ast.js.map