"use strict";
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
Object.defineProperty(exports, "__esModule", { value: true });
const ast_1 = require("../ast");
const evaluate_1 = require("../evaluate");
const errors_1 = require("../errors");
function applyMacros(state, tok) {
    let r = tok;
    for (;;) {
        if (Array.isArray(r)) {
            if (r.length === 0) {
                break;
            }
            r = evaluate_1.resolveSplice(state, r);
            const sym = ast_1.isSymbol(r[0]);
            if (sym) {
                const m = evaluate_1.resolveMacro(state, sym, r);
                if (m) {
                    r = m.fn(m.actualArgs);
                }
                else {
                    break;
                }
            }
            else {
                break;
            }
        }
        else {
            break;
        }
        errors_1.setEvaluationCount(state);
    }
    return r;
}
exports.applyMacros = applyMacros;
function stripQuote(state, tok) {
    if (!(Array.isArray(tok) && ast_1.isSymbol(tok[0], state.config.reservedNames.quote))) {
        throw new Error(`[SX] stripQuote: token is not quoted.`);
    }
    return tok[1];
}
exports.stripQuote = stripQuote;
function stripQuoteOrPass(state, tok) {
    if (Array.isArray(tok) && ast_1.isSymbol(tok[0], state.config.reservedNames.quote)) {
        return tok[1];
    }
    else {
        return tok;
    }
}
exports.stripQuoteOrPass = stripQuoteOrPass;
function getScope_stateApplied(state) {
    return (function () { return evaluate_1.getScope(state); });
}
exports.getScope_stateApplied = getScope_stateApplied;
function resolveValueSymbol_dynamic(state, varName) {
    errors_1.checkUnsafeVarNames('(compiler)resolveValueSymbol_dynamic', varName);
    return (function () { return evaluate_1.resolveValueSymbol(state, { symbol: varName }); });
}
exports.resolveValueSymbol_dynamic = resolveValueSymbol_dynamic;
function checkUnsafeVarNames_dynamic(name) {
    return (function (varName) { return errors_1.checkUnsafeVarNames(name, varName); });
}
exports.checkUnsafeVarNames_dynamic = checkUnsafeVarNames_dynamic;
//# sourceMappingURL=helpers.js.map