import { SxParserState, SxSymbol, SxToken, SxScope, CapturedScopes } from './types';
export declare function toNumber(x: any): number;
export declare function resolveUnquote(state: SxParserState, r: SxToken[]): SxToken[];
export declare function resolveSplice(state: SxParserState, r: SxToken[]): SxToken[];
export declare function resolveMacro(state: SxParserState, x: SxSymbol, r: SxToken[]): false | {
    fn: (list: SxToken[]) => SxToken;
    actualArgs: SxToken[];
};
export declare function resolveFunctionSymbol(state: SxParserState, x: SxSymbol): any;
export declare function resolveValueSymbolScope(state: SxParserState, x: SxSymbol, nullIfNotDefined: boolean): any;
export declare function resolveValueSymbol(state: SxParserState, x: SxSymbol): any;
export declare function collectCapturedVariables(state: SxParserState, names: SxSymbol[]): CapturedScopes;
export declare function getCapturedScopes(state: SxParserState): CapturedScopes | undefined;
export declare function installScope(state: SxParserState, scope: any, isBlockLocal: boolean, capturedScopes?: CapturedScopes): any;
export declare function uninstallScope(state: SxParserState): any;
export declare function getScope(state: SxParserState): SxScope;
export declare function getGlobalScope(state: SxParserState): SxScope;
export declare function matchMacroArgs(state: SxParserState, macroName: string, formalArgs: SxSymbol[], lastIsSpread: boolean, actualArgs: SxToken[]): {
    error: string;
    formalArgs?: undefined;
    actualArgs?: undefined;
} | {
    formalArgs: SxSymbol[];
    actualArgs: SxToken[];
    error?: undefined;
};
export declare function optimizeTailCall(state: SxParserState, formalArgs: SxSymbol[], fnBody: SxToken[]): any[];
export declare function evaluate(state: SxParserState, x: SxToken): SxToken;
