"use strict";
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
Object.defineProperty(exports, "__esModule", { value: true });
const ast_1 = require("../../ast");
const errors_1 = require("../../errors");
exports.macros = [{
        name: '$let-async',
        fn: (state, name) => (list) => {
            // S expression: ($let-async nameStrOrSymbol promise)
            //  -> S expr  : ($__let-async 'nameStrOrSymbol promise)
            errors_1.checkParamsLength('$let-async', list, 3, 3);
            return [{ symbol: '$__let-async' },
                ast_1.quote(state, list[1]),
                list[2],
            ];
        },
    }, {
        name: '$set-async',
        fn: (state, name) => (list) => {
            // S expression: ($set-async nameOrListOfNameOrIndex promise)
            //  -> S expr  : ($__set-async 'nameOrListOfNameOrIndex promise)
            errors_1.checkParamsLength('$set-async', list, 3, 3);
            return [{ symbol: '$__set-async' },
                ast_1.quote(state, list[1]),
                list[2],
            ];
        },
    }];
exports.default = exports.macros;
//# sourceMappingURL=concurrent.macro.js.map