"use strict";
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_operator_1 = require("./jsx.operator");
const jsx_macro_1 = require("./jsx.macro");
const jsx_symbol_1 = require("./jsx.symbol");
const jsx_fn_1 = require("./jsx.fn");
function install(config, lsxConf) {
    config.funcs = (config.funcs || []).concat(jsx_operator_1.default);
    config.macros = (config.macros || []).concat(jsx_macro_1.default);
    config.symbols = (config.symbols || []).concat(jsx_symbol_1.default);
    const components = Object.entries(lsxConf.components)
        .map(x => ({ name: x[0], fn: jsx_fn_1.$jsxComponentTag(x[1]) }));
    config.funcs = config.funcs.concat({ name: config.reservedNames.Template, fn: jsx_fn_1.$jsxComponentTag(lsxConf.jsxFlagment) }, ...components);
    config.funcSymbolResolverFallback = jsx_fn_1.$jsxStandardTag;
    config.jsx = lsxConf.jsx;
    config.JsxFragment = lsxConf.jsxFlagment;
    return config;
}
exports.default = install;
//# sourceMappingURL=index.js.map