"use strict";
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
Object.defineProperty(exports, "__esModule", { value: true });
const ast_1 = require("../../ast");
exports.macros = [{
        name: '@',
        fn: (state, name) => (list) => {
            return ast_1.quote(state, list);
        },
    }, {
        name: '$=if',
        fn: (state, name) => (list) => {
            // S expression: ($=if cond expr)
            //  -> S expr  : ($=__if cond 'expr)
            return [
                { symbol: '$=__if' },
                list[1],
                ...(list.slice(2).map(x => ast_1.quote(state, x))),
            ];
        },
    }, {
        name: '$=for',
        fn: (state, name) => (list) => {
            // S expression: ($=for list expr)
            //  -> S expr  : ($=__for list 'expr)
            return [
                { symbol: '$=__for' },
                list[1],
                ...(list.slice(2).map(x => ast_1.quote(state, x))),
            ];
        },
    }];
exports.default = exports.macros;
//# sourceMappingURL=jsx.macro.js.map