"use strict";
// Copyright (c) 2018, Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
Object.defineProperty(exports, "__esModule", { value: true });
class FatalError extends Error {
    constructor(message) {
        super(message);
    }
}
exports.FatalError = FatalError;
class MaxEvaluationCountError extends FatalError {
    constructor() {
        super(`[SX] evaluate: The maximum count of evaluations has been exceeded.`);
    }
}
exports.MaxEvaluationCountError = MaxEvaluationCountError;
class ScriptTerminationError extends FatalError {
    constructor(where) {
        super(`[SX] ${where}: Unexpected termination of script.`);
    }
}
exports.ScriptTerminationError = ScriptTerminationError;
//# sourceMappingURL=types.js.map