import { SxParserState, SxSymbol, SxToken, CapturedScopes } from '../../types';
export declare const $car: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$car: (...args: any[]) => any;
export declare const $cdr: (state: SxParserState, name: string) => (...args: any[]) => any[];
export declare const $$cdr: (...args: any[]) => any[];
export declare const $cons: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$cons: (...args: any[]) => any;
export declare const $first: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$first: (...args: any[]) => any;
export declare const $second: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$second: (...args: any[]) => any;
export declare const $last: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$last: (...args: any[]) => any;
export declare const $rest: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$rest: (...args: any[]) => any;
export declare const $firstAndSecond: (state: SxParserState, name: string) => (...args: any[]) => {
    car: any;
    cdr: any;
};
export declare const $$firstAndSecond: (...args: any[]) => {
    car: any;
    cdr: any;
};
export declare const $atom: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$atom: (...args: any[]) => boolean;
export declare const $eq: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$eq: (...args: any[]) => boolean;
export declare const $notEq: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$notEq: (...args: any[]) => boolean;
export declare const $list: (state: SxParserState, name: string) => (...args: any[]) => any[];
export declare const $$list: (...args: any[]) => any[];
export declare const $__scope: (state: SxParserState, name: string, capturedScopes?: CapturedScopes | undefined) => (...args: any[]) => SxToken;
export declare const $__globalScope: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__capture: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__lambda: (state: SxParserState, name: string) => (...args: any[]) => (this: any, ...actualArgs: any[]) => SxToken;
export declare const $comp$__lambda: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $__defun: (state: SxParserState, name: string) => (...args: any[]) => (this: any, ...actualArgs: any[]) => SxToken;
export declare const $comp$__defun: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $__refun: (state: SxParserState, name: string) => (...args: any[]) => (...args: any[]) => any;
export declare const $__defmacro: (state: SxParserState, name: string) => (...args: any[]) => (fArgs: SxSymbol[]) => (...aArgs: any[]) => SxToken;
export declare const $apply: (state: SxParserState, name: string) => (...args: any[]) => (...p: any[]) => any;
export declare const $$apply: (...args: any[]) => (...p: any[]) => any;
export declare const $__call: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $__try: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $raise: (state: SxParserState, name: string) => (...args: any[]) => never;
export declare const $$raise: (...args: any[]) => never;
export declare const $__if: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__ifNull: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__cond: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__while: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__doWhile: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__until: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__doUntil: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__repeat: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $__for: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $pipe: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$pipe: (...args: any[]) => any;
export declare const $__get: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $__let: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $__set: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $boolean: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$boolean: (...args: any[]) => boolean;
export declare const $not: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$not: (...args: any[]) => boolean;
export declare const $__and: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $$__and: (...args: any[]) => SxToken;
export declare const $__or: (state: SxParserState, name: string) => (...args: any[]) => SxToken;
export declare const $$__or: (...args: any[]) => SxToken;
export declare const $ambiguousEq: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$ambiguousEq: (...args: any[]) => boolean;
export declare const $ambiguousNotEq: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$ambiguousNotEq: (...args: any[]) => boolean;
export declare const $lt: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$lt: (...args: any[]) => boolean;
export declare const $le: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$le: (...args: any[]) => boolean;
export declare const $gt: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$gt: (...args: any[]) => boolean;
export declare const $ge: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$ge: (...args: any[]) => boolean;
export declare const $symbol: (state: SxParserState, name: string) => (...args: any[]) => {
    symbol: string;
};
export declare const $$symbol: (...args: any[]) => {
    symbol: string;
};
export declare const $__gensym: (state: SxParserState, name: string) => (...args: any[]) => {
    symbol: string;
};
export declare const $isSymbol: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$isSymbol: (...args: any[]) => boolean;
export declare const $isList: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$isList: (...args: any[]) => boolean;
export declare const $isString: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$isString: (...args: any[]) => boolean;
export declare const $isNumber: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$isNumber: (...args: any[]) => boolean;
export declare const $isNaN: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$isNaN: (...args: any[]) => boolean;
export declare const $isFinite: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$isFinite: (...args: any[]) => boolean;
export declare const $isInteger: (state: SxParserState, name: string) => (...args: any[]) => boolean;
export declare const $$isInteger: (...args: any[]) => boolean;
export declare const $toString: (state: SxParserState, name: string) => (...args: any[]) => string;
export declare const $$toString: (...args: any[]) => string;
export declare const $toNumber: (state: SxParserState, name: string) => (...args: any[]) => number;
export declare const $$toNumber: (...args: any[]) => number;
export declare const $__toObject: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $objectAssign: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$objectAssign: (...args: any[]) => any;
export declare const $jsonStringify: (state: SxParserState, name: string) => (...args: any[]) => string;
export declare const $$jsonStringify: (...args: any[]) => string;
export declare const $jsonParse: (state: SxParserState, name: string) => (...args: any[]) => any;
export declare const $$jsonParse: (...args: any[]) => any;
export declare const $now: (state: SxParserState, name: string) => (...args: any[]) => number;
export declare const $$now: (...args: any[]) => number;
export declare const $datetimeFromIso: (state: SxParserState, name: string) => (...args: any[]) => number;
export declare const $$datetimeFromIso: (...args: any[]) => number;
export declare const $datetime: (state: SxParserState, name: string) => (...args: any[]) => number;
export declare const $$datetime: (...args: any[]) => number;
export declare const $datetimeLc: (state: SxParserState, name: string) => (...args: any[]) => number;
export declare const $$datetimeLc: (...args: any[]) => number;
export declare const $datetimeToIsoString: (state: SxParserState, name: string) => (...args: any[]) => string;
export declare const $$datetimeToIsoString: (...args: any[]) => string;
export declare const $datetimeToComponents: (state: SxParserState, name: string) => (...args: any[]) => number[];
export declare const $$datetimeToComponents: (...args: any[]) => number[];
export declare const $datetimeToComponentsLc: (state: SxParserState, name: string) => (...args: any[]) => number[];
export declare const $$datetimeToComponentsLc: (...args: any[]) => number[];
export declare const $match: (state: SxParserState, name: string) => (...args: any[]) => RegExpExecArray | null;
export declare const $$match: (...args: any[]) => RegExpExecArray | null;
export declare const $consoleLog: (state: SxParserState, name: string) => (...args: any[]) => null;
export declare const $$consoleLog: (...args: any[]) => null;
export declare const $consoleError: (state: SxParserState, name: string) => (...args: any[]) => null;
export declare const $$consoleError: (...args: any[]) => null;
export declare const $consoleTrace: (state: SxParserState, name: string) => (...args: any[]) => null;
export declare const $$consoleTrace: (...args: any[]) => null;
export declare const $consoleTime: (state: SxParserState, name: string) => (...args: any[]) => null;
export declare const $$consoleTime: (...args: any[]) => null;
export declare const $consoleTimeEnd: (state: SxParserState, name: string) => (...args: any[]) => null;
export declare const $$consoleTimeEnd: (...args: any[]) => null;
export declare const $consoleTimeLog: (state: SxParserState, name: string) => (...args: any[]) => null;
export declare const $$consoleTimeLog: (...args: any[]) => null;
